// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{Ref, RefKind};
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "FlatpakBundleRef")]
    pub struct BundleRef(Object<ffi::FlatpakBundleRef, ffi::FlatpakBundleRefClass>) @extends Ref;

    match fn {
        type_ => || ffi::flatpak_bundle_ref_get_type(),
    }
}

impl BundleRef {
    pub const NONE: Option<&'static BundleRef> = None;

    #[doc(alias = "flatpak_bundle_ref_new")]
    pub fn new(file: &impl IsA<gio::File>) -> Result<BundleRef, glib::Error> {
        assert_initialized_main_thread!();
        unsafe {
            let mut error = std::ptr::null_mut();
            let ret = ffi::flatpak_bundle_ref_new(file.as_ref().to_glib_none().0, &mut error);
            if error.is_null() {
                Ok(from_glib_full(ret))
            } else {
                Err(from_glib_full(error))
            }
        }
    }

    // rustdoc-stripper-ignore-next
    /// Creates a new builder-pattern struct instance to construct [`BundleRef`] objects.
    ///
    /// This method returns an instance of [`BundleRefBuilder`](crate::builders::BundleRefBuilder) which can be used to create [`BundleRef`] objects.
    pub fn builder() -> BundleRefBuilder {
        BundleRefBuilder::new()
    }
}

impl Default for BundleRef {
    fn default() -> Self {
        glib::object::Object::new::<Self>()
    }
}

// rustdoc-stripper-ignore-next
/// A [builder-pattern] type to construct [`BundleRef`] objects.
///
/// [builder-pattern]: https://doc.rust-lang.org/1.0.0/style/ownership/builders.html
#[must_use = "The builder must be built to be used"]
pub struct BundleRefBuilder {
    builder: glib::object::ObjectBuilder<'static, BundleRef>,
}

impl BundleRefBuilder {
    fn new() -> Self {
        Self {
            builder: glib::object::Object::builder(),
        }
    }

    pub fn file(self, file: &impl IsA<gio::File>) -> Self {
        Self {
            builder: self.builder.property("file", file.clone().upcast()),
        }
    }

    pub fn arch(self, arch: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("arch", arch.into()),
        }
    }

    pub fn branch(self, branch: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("branch", branch.into()),
        }
    }

    pub fn collection_id(self, collection_id: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("collection-id", collection_id.into()),
        }
    }

    pub fn commit(self, commit: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("commit", commit.into()),
        }
    }

    pub fn kind(self, kind: RefKind) -> Self {
        Self {
            builder: self.builder.property("kind", kind),
        }
    }

    pub fn name(self, name: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("name", name.into()),
        }
    }

    // rustdoc-stripper-ignore-next
    /// Build the [`BundleRef`].
    #[must_use = "Building the object from the builder is usually expensive and is not expected to have side effects"]
    pub fn build(self) -> BundleRef {
        self.builder.build()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::BundleRef>> Sealed for T {}
}

pub trait BundleRefExt: IsA<BundleRef> + sealed::Sealed + 'static {
    #[doc(alias = "flatpak_bundle_ref_get_appstream")]
    #[doc(alias = "get_appstream")]
    fn appstream(&self) -> Option<glib::Bytes> {
        unsafe {
            from_glib_full(ffi::flatpak_bundle_ref_get_appstream(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "flatpak_bundle_ref_get_file")]
    #[doc(alias = "get_file")]
    fn file(&self) -> Option<gio::File> {
        unsafe {
            from_glib_full(ffi::flatpak_bundle_ref_get_file(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "flatpak_bundle_ref_get_icon")]
    #[doc(alias = "get_icon")]
    fn icon(&self, size: i32) -> Option<glib::Bytes> {
        unsafe {
            from_glib_full(ffi::flatpak_bundle_ref_get_icon(
                self.as_ref().to_glib_none().0,
                size,
            ))
        }
    }

    #[doc(alias = "flatpak_bundle_ref_get_installed_size")]
    #[doc(alias = "get_installed_size")]
    fn installed_size(&self) -> u64 {
        unsafe { ffi::flatpak_bundle_ref_get_installed_size(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "flatpak_bundle_ref_get_metadata")]
    #[doc(alias = "get_metadata")]
    fn metadata(&self) -> Option<glib::Bytes> {
        unsafe {
            from_glib_full(ffi::flatpak_bundle_ref_get_metadata(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "flatpak_bundle_ref_get_origin")]
    #[doc(alias = "get_origin")]
    fn origin(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_full(ffi::flatpak_bundle_ref_get_origin(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "flatpak_bundle_ref_get_runtime_repo_url")]
    #[doc(alias = "get_runtime_repo_url")]
    fn runtime_repo_url(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_full(ffi::flatpak_bundle_ref_get_runtime_repo_url(
                self.as_ref().to_glib_none().0,
            ))
        }
    }
}

impl<O: IsA<BundleRef>> BundleRefExt for O {}
